package be.iminds.ilabt.jfed.experimenter_gui.bugreporting;

import be.iminds.ilabt.jfed.call_log_output.SerializableApiCallDetails;

import java.util.Collections;
import java.util.List;

/**
 * User: twalcari
 * Date: 12/9/13
 * Time: 12:01 PM
 */

public class BugReport {

    private String description;
    private String environment;
    private String version;
    private String reporterCredential;
    private String loggedInUserInfo;
    private String mail;
    private String preferences;
    private List<SerializableApiCallDetails> calls = null;
    private List<BRConnectivityTest> connectivityTests = null;
    private List<LogLine> logLines = null;
    private List<BRSlice> slices = null;
    private String screenshot = null;

    private List<SerializableJobReport> jobReports = null;

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getEnvironment() {
        return environment;
    }

    public void setEnvironment(String environment) {
        this.environment = environment;
    }

    public String getLoggedInUserInfo() {
        return loggedInUserInfo;
    }

    public void setLoggedInUserInfo(String loggedInUserInfo) {
        this.loggedInUserInfo = loggedInUserInfo;
    }

    public String getReporterCredential() {
        return reporterCredential;
    }

    public void setReporterCredential(String reporterCredential) {
        this.reporterCredential = reporterCredential;
    }

    public String getMail() {
        return mail;
    }

    public void setMail(String mail) {
        this.mail = mail;
    }

    public List<SerializableApiCallDetails> getCalls() {
        return calls;
    }

    public void setCalls(List<SerializableApiCallDetails> calls) {
        this.calls = calls;
    }

    public List<BRConnectivityTest> getConnectivityTests() {
        return connectivityTests;
    }

    public void setConnectivityTests(List<BRConnectivityTest> connectivityTests) {
        this.connectivityTests = connectivityTests;
    }

    public List<LogLine> getLogLines() {
        return logLines;
    }

    public void setLogLines(List<LogLine> logLines) {
        this.logLines = logLines;
    }

    public List<BRSlice> getSlices() {
        return slices;
    }

    public void setSlices(List<BRSlice> slices) {
        this.slices = slices;
    }


    public List<SerializableJobReport> getJobReports() {
        if (jobReports == null) return Collections.emptyList();  //only allowed to do this because JAXB doesn't use this setter
        return jobReports;
    }
    public void setJobReports(List<SerializableJobReport> jobReports) {
        this.jobReports = jobReports;
    }

    public String getPreferences() {
        return preferences;
    }

    public void setPreferences(String preferences) {
        this.preferences = preferences;
    }

    public String getScreenshot() {
        return screenshot;
    }

    public void setScreenshot(String screenshot) {
        this.screenshot = screenshot;
    }
}
